#ifndef H_XX_TIMER
#define H_XX_TIMER

#include "BiLink.h"

class XxTimer {
private:
    typedef BlSet<XxTimer> XxTimerSet;
    XxTimerSet Member;

    static long MsCurTime;
    static long MsStartTime;
    static int  TimerCount;

    long MsTimeOut;
    long MsRestart;

    int RestartTimer (void);
    virtual void HandleTimeOut (int Count);
protected:
    XxTimer (long MsRestart = 0);
    virtual ~XxTimer (void);
    long GetTimeOut (void) { return MsTimeOut; };
public:
    static void Init (void);

    void SetTimeOut (int mSec);
    void SetRestart (int mSec);
    void Stop (void);
    int  Running (void) { return (MsTimeOut != 0); };
    static void HandleTimers (int &mSec);
    static void RefreshMsCurTime (void);
    static long GetMsCurTime  (void) { return MsCurTime;  };
    static int  GetTimerCount (void) { return TimerCount; };
};

template<class Owner> class tXxTimer : public XxTimer {
private:
    Owner *pOwner;
    virtual void HandleTimeOut (int Count);
public:
    tXxTimer (Owner *pOwner, int MsRestart = 0)
        : XxTimer (MsRestart)
    {
        tXxTimer::pOwner = pOwner;
    };
};

#endif
